function U = karchermean_Grassmann(U_cells)
    N = length(U_cells);

    [n, r] = size(U_cells{1});
    problem.M = grassmannfactory(n, r);

    problem.cost = @cost;
    problem.egrad = @egrad;

    function f = cost(U)
        f = 0;
        for i = 1:N
            U_i = U_cells{i};
            f = f + 0.5*(problem.M.norm(U, problem.M.log(U, U_i)))^2;

        end
    end

    function g = egrad(U)
        g = 0;
        for i = 1:N
            U_i = U_cells{i};
            g = g - problem.M.log(U, U_i);
        end
    end

    %     checkgradient(problem)

    U = trustregions(problem);
    
    %     (problem.M.norm(U, problem.M.log(U, U_cells{1})))^2
    %     (problem.M.norm(U, problem.M.log(U, U_cells{N})))^2
end
