clear; clc; close all;

%
N = 100; % Num tasks.
n =  10; % Num features.

mu = 1e-1;
lambda = 10;


%%
% Syenthetic train data 
for ii = 1 : N 
    j = randi(500); % Random training examples.
    data(ii).X = randn(j, n); % X for task ii.
    data(ii).y = randn(j, 1); % y for task ii.
end



% Synthetic test set
for ii = 1 : N 
    j = randi(500); % Random test examples
    data_test(ii).X = randn(j, n); % X for task ii.
    data_test(ii).y = randn(j, 1); % y for task ii.
end



%% Algorithm of Argyriou et al (2008)
problem.data = data;

% When you have data_test that follows the
% same structure of data
problem.data_test = data_test;

Omegainit = eye(n);%rand(n);
Omegainit = Omegainit*Omegainit';
Omegainit = (Omegainit + Omegainit')/2;
Omegainit = Omegainit./trace(Omegainit);



%% Alt minimization
clear params;
params.mu = mu;
params.lambda = lambda;
params.maxiter= 1000;
params.computetest = true; % If we want to compute the test rmsse, make it true.

[Omega_alt, W_alt, infos_alt] = train_alternating_epsilon_Argyriou(problem,Omegainit,params);



%% Proposed
clear params;
params.mu = mu;
params.lambda = lambda;
params.maxiter=40;
params.computetest = false; % If we want to compute the test rmsse, make it true.

params.geometry='flat';
[Omega, W, infos] = Riemannian_multitask_feature_covariance(problem, Omegainit,params);



%% Plots
% Cost.
fs = 20;
figure;
semilogy([infos.cost], 'b-o','LineWidth',2, 'MarkerSize',10);
hold on;
semilogy(infos_alt.cost, 'r-*','LineWidth',2, 'MarkerSize',10);
hold off;
ax1 = gca;
set(ax1,'FontSize',fs);
xlabel(ax1,'Iterations','FontSize',fs);
ylabel(ax1,'Cost','FontSize',fs);
legend('Proposed', 'Alt mini');
legend 'boxoff';
box off;




% testerrs = mean(test_error_unbalanced(theW,testx,testy,task_indexes_test));

