% Compute W given U
function W = computeW(U_ii, ii, problem, options)
    idx_tasks_ii = problem.agent_tasks{ii};
    W = zeros(problem.r, length(idx_tasks_ii)); % Tasks as columns.
    for t = 1:length(idx_tasks_ii)
        XitXi = problem.data(idx_tasks_ii(t)).XtX;
        Xityi = problem.data(idx_tasks_ii(t)).Xty;
        w = (options.lambda*eye(problem.r) + (U_ii'*XitXi)*U_ii)\(U_ii'*Xityi);
        W(:,t) = w;
    end
end
