function [grad_ii, cost_ii, W_ii] = computegradcost(U_ii, ii, problem, options)
    grad_ii = 0;
    cost_ii = 0;
    idx_tasks_ii = problem.agent_tasks{ii};
    W_ii = computeW(U_ii, ii, problem, options);
    for t = 1:length(idx_tasks_ii)
        w = W_ii(:, t);
        grad_ii =  grad_ii + problem.data(idx_tasks_ii(t)).XtX*(U_ii*(w*w')) - problem.data(idx_tasks_ii(t)).Xty*w';
        cost_ii = cost_ii + 0.5*norm(problem.data(idx_tasks_ii(t)).X*U_ii*w - problem.data(idx_tasks_ii(t)).y ,'fro')^2 ...
            + 0.5*options.lambda*(w'*w);
    end
    
    % Riemannian gradient
    grad_ii = grad_ii - U_ii*(U_ii'*grad_ii);
    
    %     % Debug
    %     norm(U_ii'*grad_ii, 'fro')
end
